/*
 *  Lexeur.h
 *  Calcul
 *
 *  Created by Thomas Jannaud on 31/01/08.
 *  Copyright 2008 __Jannaud's Technical Company__. All rights reserved.
 *
 */
#include <list>
#include <string>
#include <iostream>

using namespace std;

arbre * tout_faire(string);
arbre* analyser(char *, int);
string pretraitement(char*, int);
list<carac*> creer_liste(char *, int);
void remplacer(string&, int, string, string);
int trouve(char*, char);
int trouve_parenthese_fermante(char*);
int lire_nombre(char * p, double &d);
list<carac*>::iterator avance(list<carac*>::iterator);
list<carac*>::iterator recule(list<carac*>::iterator);
bool est_une_fonction(char);

arbre * tout_faire(string s) {
	char p[s.length() + 1];
	for(int i = 0; i < s.length(); i++)
		p[i] = s[i];
	p[s.length()] = 0;
	string s2 = pretraitement(p, s.length());
	char q[s2.length() + 1];
	for(int i = 0; i < s2.length(); i++)
		q[i] = s2[i];
	q[s2.length()] = 0;
	return analyser(q,s2.length());
	
}

string pretraitement(char* p, int n) {
	string s(p, n);
	for(int i = 0; i < n; i++) //on met les variables en minuscules
		if (s[i] >= 'A' && s[i] <= 'Z')
			s[i] += 'a' - 'A';
	
	for(map<char, string>::iterator i = operateurunaire::equiv.begin(); i != operateurunaire::equiv.end(); i++)
		remplacer(s, n, i->second, string(1, i->first)); // on remplace "sin" par "S", ...
	remplacer(s, n, " ", "");
	remplacer(s, n, "sum", "Y");
	remplacer(s, n, "prod", "Z");
	remplacer(s, n, ",", ")(");
	remplacer(s, n, "rnd", "X");
	
	n = s.length(); // le signe pour le - de 2 - 3 est '_' ; le - est pour dire qu'un nombre est négatif. On essaye ici de corriger l'erreur
	for(int i = 1; i < n; i++) // de l'utilisateur
		if (s[i] == '-' && (s[i-1] != '(' or s[i-1] != '+' or s[i-1] != '*' or s[i-1] != '/'))
			s[i] = '_';
	bool ok = true;
	while(ok) {
		ok = false;
		n = s.length();
		for(int i = 0; !ok && (i < (n-1)); i++)
			if (s[i] == '-' && (s[i+1] < '0' or s[i+1] > '9' or s[i+1] != '.')) {
				s.replace(i, 1, "-1.*");
				ok=true;
			}
	}
	return s;
}

// la chaine est supposée être pré-traitée : remplacer "sin" par 'S', ... attention aux '-' et '_', ...
arbre* analyser(char * p, int n) { 
	list<carac*> l = creer_liste(p, n);
	list<carac*>::iterator i, j, k, ll, m, nn;
	
	// fonctions ∑ et ∏
	for(i = l.begin(); i != l.end(); i++) {
		if ((*i)->mongenre == grossefonc) {
			j = avance(i); k = avance(j); ll = avance(k); m = avance(ll); nn = avance(m);
			*i = new carac(new grossesfonctions((*j)->larbre, (*i)->lechar, (*k)->lechar, (*ll)->larbre, (*m)->larbre, (*nn)->larbre));
			l.erase(j);	l.erase(k); l.erase(ll); l.erase(m); l.erase(nn);
		}
	}
	
	// fonctions
	for(i = l.begin(); i != l.end(); i++) {
		if ((*i)->mongenre == fonction) {
			j = avance(i);
			*i = new carac(new operateurunaire((*j)->larbre, (*i)->lechar));
			l.erase(j);
		}
	}
	
	// ^
	for(i = l.begin(); i != l.end(); i++) {
		if ((*i)->mongenre == signe && (*i)->lechar == '^') {
			j = recule(i); k = avance(i);
			*i = new carac(new operateurbinaire((*j)->larbre, (*k)->larbre, (*i)->lechar));
			l.erase(j); l.erase(k);
		}
	}
	
	// * et /
	for(i = l.begin(); i != l.end(); i++) {
		if ((*i)->mongenre == signe && ((*i)->lechar == '*' or (*i)->lechar == '/')) {
			j = recule(i); k = avance(i);
			*i = new carac(new operateurbinaire((*j)->larbre, (*k)->larbre, (*i)->lechar));
			l.erase(j); l.erase(k);
		}
	}
	
	// + et -
	for(i = l.begin(); i != l.end(); i++) {
		if ((*i)->mongenre == signe){
			j = recule(i); k = avance(i);
			*i = new carac(new operateurbinaire((*j)->larbre, (*k)->larbre, (*i)->lechar));
			l.erase(j); l.erase(k);
		}
	}
	
	return l.front()->larbre;
}

list<carac*> creer_liste(char * p, int n) {
	list<carac*> l;
	for(int i = 0; i < n; i++) {
		char c = p[i];
		if (c == '+' or c == '_' or c == '*' or c == '/' or est_une_fonction(c)) // sin, cos, ... ou sum ou prod
			l.push_back(new carac(c));
		else if (c == '(') {
			int a = trouve_parenthese_fermante(p + i);
			if (a == (-1))
				throw 1;
			arbre * b = analyser(p + i + 1, a - 1);
			l.push_back(new carac(b));
			if (a == 2) l.back()->lechar = p[i+1];
			i += a;
		}
		else if (c == ')') 
			throw 1;
		else if (c == '.' or c == '-' or (c >= '0' && c <= '9')) {
			double d;
			int a = lire_nombre(p + i, d);
			if (a < 0)
				throw 1;
			i += a;
			Variable * v = new Variable(d);
			l.push_back(new carac(v));
		}
		else {
			Variable* v = new Variable(c);
			l.push_back(new carac(v));
		}
	}
	return l;
}

int trouve(char * p, char c) {
	for(int i = 0; p[i] != 0; i++)
		if (p[i] == c) 
			return i;
	return (-1);
}

int trouve_parenthese_fermante(char * p) { // *p = '(' normalement
	int s = 0;
	for(int i = 0; p[i] != 0; i++) {
		if (p[i] == '(')
			s++;
		if (p[i] == ')')
			s--;
		if (s == 0)
			return i;
	}
	return (-1);
}

int lire_nombre(char * p, double &d) { // on met dans d le nombre lu, et on renvoie l'indice du dernier caractère APPARTENANT au nombre
	bool negatif = (*p == '-');
	if (negatif) p++;
	
	int i;
	double positif = 0.0, power = .1;
	// avant la virgule
	i = 0;
	while(p[i] != 0 && p[i] >= '0' && p[i] <= '9') {
		positif = 10. * positif + (p[i] - '0');
		i++;
	}
	if (p[i] != '.') {
		d = (negatif) ? (-positif) : positif;
		return ((negatif) ? i : (i - 1));
	}
	// après la virgule
	i++;
	while(p[i] != 0 && p[i] >= '0' && p[i] <= '9') {
		positif += (p[i] - '0') * power;
		i++;
		power /= 10;
	}
	d = (negatif) ? (-positif) : positif;
	return ((negatif) ? i : (i - 1));
}

list<carac*>::iterator avance(list<carac*>::iterator i) {
	i++;
	return i;
}

list<carac*>::iterator recule(list<carac*>::iterator i) {
	i--;
	return i;
}

void remplacer(string& s, int n, string s1, string s2) {
	while(s.find(s1) != string::npos)
		s.replace(s.find(s1), s1.length(), s2);
}

bool est_une_fonction(char c) {
	return (c == 'Y' or c == 'Z' or operateurunaire::equiv.count(c) != 0);
}
