/*
 *  Variable.cpp
 *  calcul
 *
 *  Created by Thomas Jannaud on 29/01/08.
 *  Copyright 2008 __Jannaud's Technical Company__. All rights reserved.
 *
 */

#include <stdio.h>
#include <map>
#include <time.h>
#include <stdlib.h>
#include <string>
#include <iostream>
#include <iomanip>
#include <sstream>
#include "arbre.h"
#include "Variable.h"

using namespace std;

Variable::Variable(double x) {
	this->valeur = x;
	letype = constante;
}

Variable::Variable(char x) {
	this->val = x;
	letype = variante;
}

arbre* Variable::clone() {
	if (letype==variante)
		return new Variable(val);
	else
		return new Variable(valeur);
}


double Variable::evalue(std::map<char,double> table) {
	if (letype == variante) {
		if (this->val == 'X')
			return ((double) rand());
		else if (table.count(this->val) == 0)
			throw 1;
		else
			return table[this->val];
	}
	else
		return this->valeur;
}

string Variable::to_string() {
	if (letype == variante && (this->val == 'X'))
		return "rand()";
	else if (letype == variante)
		return string(1, this->val);
	else
		return double2string(this->valeur);
}

string double2string(double d)
{
	ostringstream format_message;
	format_message << setprecision(12) << d;
	return format_message.str();
}

bool Variable::occurence(char x) {
	return (letype == variante && val == x);
}

arbre* Variable::deriver(char x) {
	if (this->occurence(x))
		return new Variable(1.0);
	else
		return new Variable(0.0); // n'est pas sensé arriver jusque là
}

bool Variable::isvariable(double x) {
	if (letype == variante) 
		return false;
	else
		return (this->valeur == x);
}