/*
 *  operateurunaire.h
 *  Calcul
 *
 *  Created by Thomas Jannaud on 31/01/08.
 *  Copyright 2008 __Jannaud's Technical Company__. All rights reserved.
 *
 */

#include <stdio.h>
#include <map>
#include <cmath>
#include <string>
#include "arbre.h";
#include "noeud.h"
#include "Variable.h"
#include "operateurbinaire.h"
#include "operateurunaire.h"

using namespace std;
map<char, string> operateurunaire::equiv;

operateurunaire::operateurunaire(arbre * a, char fonction) : noeud(a, 0) {
	this->operateur = fonction;
}

operateurunaire::operateurunaire(const operateurunaire & rhs) : noeud(rhs) { // ca marche pas... mais je sais pas pourquoi
	this->operateur = rhs.operateur;
}

arbre* operateurunaire::clone() {
return new operateurunaire(this->fils_g->clone(), this->operateur);
//	return new operateurunaire(*this);
}

double operateurunaire::evalue(std::map<char,double> table) {
	double a = this->fils_g->evalue(table);
	switch (this->operateur) {
		case 'S':
			return sin(a);
		case 'C':
			return cos(a);
		case 'T':
			return tan(a);
		case 'B':
			return atan(a);
		case 'D':
			return asin(a);
		case 'F':
			return acos(a);
		case 'E':
			return exp(a);
		case 'L':
			return log(a);
		case 'R':
			return sqrt(a);
		case 'A':
			return abs(a);
		case 'G': // fonction signe
			if (a > 0.)
				return 1.;
			else if (a < 0.)
				return (-1.);
			else
				return 0.;
		default:
			throw 3;
			break;
	}
}	

string operateurunaire::to_string() {
	return (string(equiv[operateur]) + "(" + fils_g->to_string() + ")");
}

bool operateurunaire::occurence(char x) {
	return fils_g->occurence(x);
}

arbre * operateurunaire::deriver(char x) {
arbre * a = 0;
	if (!this->occurence(x))
		return new Variable(0.);
	
	switch (this->operateur) {
		case 'S': // sin
			return new operateurbinaire(this->fils_g->deriver(x), new operateurunaire(this->fils_g->clone(), 'C'), '*');
		case 'C':// cos
			a = new operateurbinaire(this->fils_g->deriver(x), new operateurunaire(this->fils_g->clone(), 'S'), '*');
			return new operateurbinaire(new Variable(-1.0), a, '*');
		case 'T': // tan
			return new operateurbinaire(this->fils_g->deriver(x), new operateurbinaire(new operateurunaire(this->clone(), 'C'), new Variable(2.0), '^'), '/');
		case 'B': // atan
			a = new operateurbinaire(new Variable(1.0), new operateurbinaire(this->fils_g->clone(), new Variable(2.0), '^'), '+');
			return new operateurbinaire(fils_g->deriver(x), a,'/');
		case 'D': // asin
			a = new operateurbinaire(new Variable(1.0), new operateurbinaire(this->fils_g->clone(), new Variable(2.0), '^'), '_');
			return new operateurbinaire(fils_g->deriver(x), new operateurunaire(a, 'R'),'/');
		case 'F': // acos
			a = new operateurbinaire(new Variable(1.0), new operateurbinaire(this->fils_g->clone(), new Variable(2.0), '^'), '_');
			return new operateurbinaire(new operateurbinaire(new Variable(-1.0), fils_g->deriver(x), '*'), new operateurunaire(a, 'R'),'/');
		case 'E': // exp
			return new operateurbinaire(this->fils_g->deriver(x), this->clone(), '*');
		case 'L': // log
			return new operateurbinaire(this->fils_g->deriver(x), this->fils_g->clone(), '/');
		case 'R': // sqrt
			return new operateurbinaire(this->fils_g->deriver(x), new operateurbinaire(new Variable(2.), this->clone(), '*'), '/');
		case 'A': // abs
			return new operateurbinaire(this->fils_g->deriver(x), new operateurunaire(this->fils_g->clone(), 'G'), '*'); // 'G' : fonction signe
		case 'G': // signe
			return new Variable(0.);
		default:
			throw 3;
			break;
	}
}

arbre * operateurunaire::reduire() {
	try{
	map<char, double> tableauvide;
	fils_g->evalue(tableauvide);
	return new Variable(this->evalue(tableauvide));
	}
	catch (...) {	};
return this->clone();
}